# checkmk CVE-log4j agent plugin

This agent plugin intergrates the [CVE-2021-44228-Scanner from logpresso](https://github.com/logpresso/CVE-2021-44228-Scanner) with [checkmk](https://checkmk.com/) the system monitoring from [tribe29](https://tribe29.com/).

Included in this package is the scanner for Linux and Windows in version 2.7.1 (2022-01-02). You will find the release notes/latest version for the logpresso scanner here [logpresso CVE-2021-44228-Scanner Releases](https://github.com/logpresso/CVE-2021-44228-Scanner/releases).

**Note:** The package for CMK1.6 will not be always on the same level as the version for CMK 2.0. 

The scanner (and so the plugin) can discover the following log4j issues

- CVE-2021-44228
- CVE-2021-4104
- CVE-2021-42550
- CVE-2021-45105
- CVE-2021-45046
- CVE-2021-44832 RCE

You will find more information on this on the [Apache Log4j Security Vulnerabilities](https://logging.apache.org/log4j/2.x/security.html) page.

---
### Download
* [cve_2021_44228_log4j.mkp (plugin for CMK 2.0)](https://github.com/thl-cmk/CVE-log4j-check_mk-plugin/raw/master/cve_2021_44228_log4j.mkp)
* [cve_2021_44228_log4j_cmk16.mkp (plugin for CMK 1.6)](https://github.com/thl-cmk/CVE-log4j-check_mk-plugin/raw/master/cve_2021_44228_log4j_cmk16.mkp)

You can find the latest version of this plugin and a lot more checkmk plugins [here](https://thl-cmk.hopto.org/gitlab/checkmk/vendor-independent/cve_2021_44228_log4j)

**Note**: before you update read the [CHANGELOG](CHANGELOG) please, and have a look at the [Releases](https://github.com/thl-cmk/CVE-log4j-check_mk-plugin/releases), there might be unexpected changes.

---
### Install
* in the checkmk Entrprise/Free edition you can install the plugin via _`Setup > Maintenance > Extension packages`_
* in the checkmk RAW/Community edition you need to copy the package to your checkmk server (via SCP for example), and then - as site user - install the package with `mkp install cve_2021_44228_log4.mkp` on the cli.

---
### How to use
To use this plugin you need to deploy the scanner and the plugin for your destination platform. You can do this via the agent bakery (_`Setup > Agents> Windows, Linux, Solaris, AIX > Agent rules > CVE-2021-44228-log4j`_). Here you can also configure some options for the scanner [(see WATO bakery)](doc/wato-bakery-linux.png "WATO bakery"). If you have created (baked) a new agent package you need to redeploy the agent (automatic update/software deployment)

To use this plugin with the checkmk RAW/Community edition or have a platform that is not supported by the bakery have a look at the [how to information](HOWTO.md "how to"). There you will also find more information around this plugin.

**Note**: only Linux and Windows is implemented for this bakery plugin. If you need this for AIX/Solaris have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
#### Want to contribute?
Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info:

* *service*: creates the service **CVE-2021-44228-log4j**
---
* *state*:\
    **critical**
    - if a (potentially) vulnerable file is found
    - if an error is found (from the agent plugin or the scanner)

    **warning**
    - if a file state mitigated is found
    - if a file is skipped by the scanner
---
* *wato*: [(see WATO options)](doc/wato.png "see sample screenshot")
---
* *perfdata (if avilable)*: 
    * Vulnerable files
    * Potentially vulnerable files
    * Mitigated files
    * Files sskipped
    * Files scanned
    * Directories scanned
    * Run time
---

<details><summary>Sample output</summary>
 
**Note**: in the service details you will find the raw output from the scanner

![sample output](/doc/sample.png?raw=true "sample output")

<details><summary>Sample output details</summary>

 ![(sample details)](doc/sample-details.png "see sample details")

</details>

<details><summary>Sample syslog events in CMK event console</summary>

![(sample syslog events in CMK event console)](doc/sample-syslog.png "sample syslog events in CMK event console")

</details>
   
<details><summary>Sample inventory output</summary>

![(sample inventory search)](doc/sample-inventory.png "sample inventory search")

</details>

</details>
<details><summary>WATO options check plugin</summary>

![WATO options check plugin ](doc/wato.png "WATO options")
</details>

<details><summary>WATO bakery Linux</summary>

![WATO bakery Linux](doc/wato-bakery-linux.png "WATO bakery Linux")

</details>

<details><summary>WATO bakery Windows</summary>

![WATO bakery Windows](doc/wato-bakery-windows.png "WATO Windows")

</details>
